SystemOrganization addCategory: #tp1!
SystemOrganization addCategory: #Tp1!

Object subclass: #Alumno
	instanceVariableNames: 'legajo nombre cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos
	^ cursos! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
cursos: anObject
	cursos := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo
	^ legajo! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
legajo: anObject
	legajo := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre
	^ nombre! !

!Alumno methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 15:34'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Curso
	instanceVariableNames: 'docentes alumnos nombreMateria anio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1'!

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:52'!
Inicializar
	alumnos:= Dictionary new.
	alumnos at: 'macha' put: 5.
	alumnos at: 'diego' put: 8. 
	alumnos at: 'julian' put: 2. 
	alumnos at: 'pedro' put: -1. ! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
alumnos
	^ alumnos! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
alumnos: anObject
	alumnos := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
anio
	^ anio! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
anio: anObject
	anio := anObject! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 14:41'!
cantidadDeAbandono

	^ (alumnos select: [:x | x = -1]) size . 
! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 14:40'!
cantidadDeAprobados

	^ (alumnos select: [:x | x > 4]) size . 
! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 14:57'!
cuantasNotasCon: laNota
	"comment stating purpose of message"

	^ (alumnos select: [:x | x = laNota]) size.! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 15:21'!
cuantasNotasMayorA: laNota
	"comment stating purpose of message"

	^ (alumnos select: [:x | x >= laNota]) size.! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
docentes
	^ docentes! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
docentes: anObject
	docentes := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
nombreMateria
	^ nombreMateria! !

!Curso methodsFor: 'accessing' stamp: 'Anonymous 9/7/2013 14:49'!
nombreMateria: anObject
	nombreMateria := anObject! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 15:31'!
notaMasAltaNVeces: cantidad


	| colecciontemp |
	colecciontemp := {10. 9. 8. 7. 6. 5. 4. 3. 2. 1. 0}.
	
	colecciontemp do: [ :x | ((self cuantasNotasMayorA: x) >= cantidad ) ifTrue: [ ^ x ] ifFalse: [x = 0 ifTrue: [^ 'No habia notas suficientes']  ] ]. ! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 14:55'!
porcentajeDeAprobadosSobreTotal

	| total |
	total := alumnos size . 
	^ (self cantidadDeAprobados / total) * 100 .
! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 14:38'!
promedioConAplazos

	^ (alumnos sum: [ :x | x]) / (alumnos size).  
! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 14:37'!
promedioSinAplazos

	| listaFiltrada |
	listaFiltrada := (alumnos select: [:x | x > 3]).
	^ ( listaFiltrada sum: [ :x | x]) / (listaFiltrada size).  
! !

!Curso methodsFor: 'dominio' stamp: 'Anonymous 9/7/2013 15:15'!
tablaNotas
	"comment stating purpose of message"
	|colecciontemp coleccionReturn |

	colecciontemp := {0. 1. 2. 3. 4. 5. 6. 7. 8. 9. 10}.
	coleccionReturn := Dictionary  new.
	colecciontemp 	do: [ :x |  coleccionReturn at: x put: (self cuantasNotasCon: x)].
	^coleccionReturn! !
